<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<%
/****************************************************************************/
/*                                                                          */
/* Program name: JTEAINPUT.jsp                                              */
/*                                                                          */
/* Description: Sanple JSP file for input TEA data                          */
/*                                                                          */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac WA84                                    */
/*              (C) Copyright IBM Corp. 2001                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-December-2001  JWH  Initial release                            */
/*                                                                          */
/*==========================================================================*/
/* Module Name: JTEAINPUT.jsp                                               */
/*==========================================================================*/
%>
<%@ page language="java" info="JspWizard" %>
<%@ page import="com.ibm.workflow.api.*" %>
<%@ page import="com.ibm.workflow.api.ItemPackage.*" %>
<%@ page import="com.ibm.workflow.servlet.client.*" %>
<%@ page import="com.ibm.workflow.servlet.clientx.wext.*" %>
<jsp:useBean id="context" scope="request"
             type="com.ibm.workflow.servlet.client.RequestContext"/>
<jsp:useBean id="pageController" scope="session"
             class="com.ibm.workflow.servlet.clientx.wext.PageController"
             type="com.ibm.workflow.servlet.clientx.wext.PageController"/>
<jsp:useBean id="reuseData" scope="request"
             class="com.ibm.workflow.servlet.clientx.wext.ReuseData"
             type="com.ibm.workflow.servlet.clientx.wext.ReuseData"/>

<%
    ReadOnlyContainer inData = context.getContainer();
    WorkItem workItem = context.getWorkItem();
    ReadWriteContainer outrwData = workItem.outContainer();
    ReadOnlyContainer outData = outrwData.asReadOnlyContainer();

    if (pageController.getReuseData() != reuseData) {
        pageController.setReuseData(reuseData);
    }
    pageController.initPage();
    pageController.putPage("1", "/programs/JTEAINPUT.jsp");
    pageController.putPage("2", "/programs/JTEAENTINPUT.jsp");
    pageController.setEventListenerObject(this);
%>
<%!
public String getStringMember(RequestContext context, ReadOnlyContainer input, String name) {
    String val = null;

    try {
      val = context.getMemberValue(input, name, "");
    }
    catch (Exception e) {
    }

    return val;
}

public double getDoubleMember(RequestContext context, ReadOnlyContainer input, String name) {
    String val = null;
    double rtn = 0.0;

    try {
      val = context.getMemberValue(input, name, "0.0");
      rtn = Double.parseDouble(val);
    }
    catch (Exception e) {
    }

    return rtn;
}

public double getDoubleReuse(ReuseData res, String name) {
    String val = null;
    double rtn = 0.0;

    try {
      val = res.getValue(name);
      rtn = Double.parseDouble(val);
    }
    catch (Exception e) {
    }

    return rtn;
}

public int getLongMember(RequestContext context, ReadOnlyContainer input, String name) {
    String val = null;
    int rtn = 0;

    try {
      val = context.getMemberValue(input, name, "0");
      rtn = Integer.parseInt(val);
    }
    catch (Exception e) {
    }

    return rtn;
}

public int getLongReuse(ReuseData res, String name) {
    String val = null;
    int rtn = 0;

    try {
      val = res.getValue(name);
      rtn = Integer.parseInt(val);
    }
    catch (Exception e) {
    }

    return rtn;
}
%>



<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<META name="GENERATOR" content="IBM WebSphere Page Designer V3.5.3 for Windows">
<META http-equiv="Content-Style-Type" content="text/css">
<title></title>
</head>

<body>
<FORM method="post" action='<%=context.getCommand("x-checkInWorkItem",workItem.persistentOid())%>'>
<!-- METADATA name="JspWizard" startspan --><BR>
<CENTER><B><U>Travel Expense Request</U></B></CENTER>
<BR>
<TABLE border="1" width="100%">
  <TBODY>
    <TR>
      <TD colspan="3" bgcolor="#cccccc" width="354">Requester Information</TD>
      <TD colspan="2" bgcolor="#cccccc" width="416">Organization Information</TD>
    </TR>
    <TR>
      <TD colspan="2">First Name </TD>
      <TD><%
/* GENERATED_BY_MQWF_RAPID_DEPLOYMENT name="FirstName" type="static" */
out.println(getStringMember(context, inData, "FirstName"));
%></TD>
      <TD><INPUT type="hidden" name="Requester.FirstName" value="<%=getStringMember(context, inData, "FirstName") %>">

<INPUT type="hidden" name="Requester.LastName" value="<%=getStringMember(context, inData, "LastName") %>">Department Name</TD>
      <TD><INPUT type="text" name="RequesterORG.DeptName" value="<%=reuseData.getHTMLValue("RequesterORG.DeptName")%>"></TD>
    </TR>
    <TR>
      <TD colspan="2">Last Name</TD>
      <TD><%
/* GENERATED_BY_MQWF_RAPID_DEPLOYMENT name="LastName" type="static" */
out.println(getStringMember(context, inData, "LastName"));
%></TD>
      <TD>Department Number</TD>
      <TD><INPUT type="text" name="RequesterORG.DeptNum" value="<%=reuseData.getHTMLValue("RequesterORG.DeptNum")%>"></TD>
    </TR>
    <TR>
      <TD colspan="3" width="354">&nbsp;</TD>
      <TD>Manager Name</TD>
      <TD><INPUT type="text" name="RequesterORG.MangName" value="<%=reuseData.getHTMLValue("RequesterORG.MangName")%>"></TD>
    </TR>
  </TBODY>
</TABLE>
<BR>
<BR>
<TABLE border="1" width="100%">
  <TBODY>
    <TR>
      <TD colspan="7" bgcolor="#cccccc">Summary of Expense Items</TD>
    </TR>
    <TR>
      <TD>&nbsp;</TD>
      <TD>Description</TD>
      <TD width="100">Expense Date</TD>
      <TD width="117">Amount</TD>
      <TD>Local Currency</TD>
      <TD>Exchange Rate</TD>
      <TD>Converted Amount</TD>
    </TR>
<%
    double tt = 0;
    int j;
    for (j = 0; j < 20; j++) {
        double t = getDoubleReuse(reuseData, "ExpenseItems["+j+"].ConvertedAmount");
        if (t == 0)
            break;
        tt = tt + t;
%>
    <TR>
      <TD> <% out.println(j+1); %><INPUT type="button" name="Edit" value="Edit" onclick="javascript:{ document.forms[0].TmpTarget.value = '<%=j %>'; this.form.action='<%=context.getCommand("changePage", workItem.persistentOid(), "&x-pid=2")%>'; this.form.submit(); }"></TD>
      <TD><%
/* GENERATED_BY_MQWF_RAPID_DEPLOYMENT name="ExpenseItems[j].Description" type="static" */
out.println( reuseData.getHTMLValue( "ExpenseItems["+j+"].Description"));
%></TD>
      <TD width="100"><%
/* GENERATED_BY_MQWF_RAPID_DEPLOYMENT name="ExpenseItems[0].ExpenseDate" type="static" */
out.println( reuseData.getHTMLValue( "ExpenseItems["+j+"].ExpenseDate"));
%></TD>
      <TD width="117"><%
/* GENERATED_BY_MQWF_RAPID_DEPLOYMENT name="ExpenseItems[0].Amount" type="static" */
out.println(getDoubleReuse(reuseData, "ExpenseItems["+j+"].Amount"));
%></TD>
      <TD><%
/* GENERATED_BY_MQWF_RAPID_DEPLOYMENT name="ExpenseItems[0].Currency" type="static" */
out.println(reuseData.getHTMLValue( "ExpenseItems["+j+"].Currency"));
%></TD>
      <TD><%
/* GENERATED_BY_MQWF_RAPID_DEPLOYMENT name="ExpenseItems[0].ExchangeRate" type="static" */
out.println(getDoubleReuse(reuseData, "ExpenseItems["+j+"].ExchangeRate"));
%></TD>
      <TD><%
/* GENERATED_BY_MQWF_RAPID_DEPLOYMENT name="ExpenseItems[0].ConvertedAmount" type="static" */
out.println(getDoubleReuse(reuseData, "ExpenseItems["+j+"].ConvertedAmount"));
%></TD>
    </TR>
<%

    }
%>

    <TR>
      <TD colspan="5">&nbsp;</TD>
      <TD>Total Expense</TD>
      <TD><INPUT type="text" name="TotalExpence" value="<%out.println(tt);%>" size="16" readonly></TD>
    </TR>
  </TBODY>
</TABLE>
<INPUT type="button" name="changePage" value="Add an Expense Item" onclick="javascript:{ document.forms[0].TmpTarget.value = '<%=j %>'; this.form.action='<%=context.getCommand("x-changePage", workItem.persistentOid(), "&x-pid=2")%>'; this.form.submit(); }">
<input type="hidden" name="TmpTarget" >
<br>

<INPUT type="hidden" name="Requester.FirstName" value="<%=getStringMember(context, inData, "FirstName") %>"><INPUT type="hidden" name="Requester.LastName" value="<%=getStringMember(context, inData, "LastName") %>"><br>
<FONT color="#ff0000" size="+2"><%
    String err = reuseData.getValue("ERR");

    if (err != null && !err.equals("")) {
        out.println("Error Message: " + err);
    }
%></FONT><br>
<!-- METADATA name="JspWizard" endspan -->

<hr>

<input type="button" name="completeWorkitem" value="Complete Activity" onClick="this.form.action='<%=context.getCommand("x-completeWorkItem", workItem.persistentOid())%>';this.form.submit();">

<input type="button" name="checkinWorkitem" value="Save as Draft" onClick="this.form.action='<%=context.getCommand("x-checkInWorkItem", workItem.persistentOid())%>';this.form.submit();">

<INPUT type="button" name="retrieveDraftWorkItem" value="Cancel (Back to Saved Draft)" onclick="this.form.action='<%=context.getCommand("x-retrieveDraftWorkItem", workItem.persistentOid())%>';this.form.submit();">

<INPUT type="button" name="x-cancelWorkItem" value="Cancel (Destroy Saved Draft) " onclick="this.form.action='<%=context.getCommand("x-cancelWorkItem", workItem.persistentOid())%>';this.form.submit();">

</FORM>
</body>

</html>

<%!
public ResponsePage queryPageChange(RequestContext context, PageController controller, PostedValues values) {
    int entmax = 5;

    ReuseData reuseData = controller.getReuseData();
    context.log("executed queryPageChange", false);
    String page = values.getParameter("TmpTarget");
    int tmp = Integer.parseInt(page);
    if (tmp < entmax)
        return null;
    reuseData.setValue("ERR", "Enpense entry is limited to " + entmax);
    return new ResponsePage(context, "/programs/JTEAINPUT.jsp");
}

public ResponsePage queryCheckInWorkItem(RequestContext context, PageController controller, PostedValues values) {
    if ("x-checkInWorkItem".equals(controller.getLastCommand())) {
        // no error check for draft check-in
        return null;
    }
    // for x-completeWorkItem
    ReuseData reuseData = controller.getReuseData();
    context.log("executed queryCheckInWorkItem", false);
    String man = values.getParameter("RequesterORG.MangName");
    if (man == null)
        man = reuseData.getValue("RequesterORG.MangName");
    if (man != null && man.length() != 0) {
        reuseData.setValue("ERR", "");
        return null;
    }
    reuseData.setValue("ERR", "Manager field is required");
    return new ResponsePage(context, "/programs/JTEAINPUT.jsp");
}
%>